Subject: Re: BUG: stdin not a constant
From: [email-masked] (Fergus Henderson)

4 Dec 1997 01:22:39 -0800
Message-ID: <[email-masked]>
References: <[email-masked]>
To: [email-masked]
Cc: [email-masked]

Peter David ROSS <[email-masked]> writes:

>The following code doesn't compile. 
>
>------
>#include <stdio.h>
>
>static FILE *out = stdout;
>
>void main(void)
>{
>    /* out = stdout; */
>    fprintf(out, "hello world\n");
>}

That code is not ANSI/ISO-conformant C.
The ANSI/ISO C standard does not require `stdout' to be a constant
suitable for use in a static initializer.

>The fix is to remove the initialiser and add the line which is commented out.

Correct.

>However the code I am trying to port has these sort of variables spread
>all over the place,

You have my sympathy ;-)

>and I would like to know if there is someway I can
>get the compiler to treat it as a constant.

I'm fairly sure there's no simple way.
I think you'll just have to fix your non-conformant source code.

--
Fergus Henderson <[email-masked]>   |  "I have always known that the pursuit
WWW: <http://www.cs.mu.oz.au/~fjh>   |  of excellence is a lethal habit"
PGP: finger [email-masked]         |     -- the last words of T. S. Garp.
-
For help on using this list (especially unsubscribing), send a message to
"[email-masked]" with one line of text: "help".